# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We don't really need Module::Build::Tiny ≥ 0.035
%global old_mbt %(perl -MModule::Build::Tiny -e 'print (($Module::Build::Tiny::VERSION < 0.035) ? 1 : 0);' 2>/dev/null || echo 0)

# We need Test::More ≥ 0.94, so use a bundled one if we don't have it
%global test_more_lt094 %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.94) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-Test-CleanNamespaces
Summary:	Check for uncleaned imports
Version:	0.08
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		https://metacpan.org/release/Test-CleanNamespaces
Source0:	http://cpan.metacpan.org/authors/id/E/ET/ETHER/Test-CleanNamespaces-%{version}.tar.gz 
Source1:	T-M-0.96.tar.gz
Patch0:		Test-CleanNamespaces-0.07-old-M:B:T.patch
Patch1:		Test-CleanNamespaces-0.08-no-Test::Requires.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	perl(Module::Build::Tiny) >= 0.030
# Module
BuildRequires:	perl(File::Find::Rule)
BuildRequires:	perl(File::Find::Rule::Perl)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(Module::Runtime)
BuildRequires:	perl(namespace::clean)
BuildRequires:	perl(Package::Stash)
BuildRequires:	perl(Package::Stash::XS)
BuildRequires:	perl(strict)
BuildRequires:	perl(Sub::Exporter)
BuildRequires:	perl(Sub::Identify)
BuildRequires:	perl(Sub::Name)
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(CPAN::Meta)
BuildRequires:	perl(CPAN::Meta::Requirements) >= 2.120900
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(lib)
BuildRequires:	perl(List::Util)
BuildRequires:	perl(parent)
BuildRequires:	perl(Role::Tiny)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Test::Fatal)
BuildRequires:	perl(Test::More)
# Test::Requires needs Test::Builder::Module, only available with perl ≥ 5.8.8 (FC-5 onwards)
%if %(perl -e 'print $] >= 5.008008 ? 1 : 0;')
BuildRequires:	perl(Test::Requires)
%endif
BuildRequires:	perl(Test::Tester)
BuildRequires:	perl(version)
# Optional Test Requirements
%if 0%{!?perl_bootstrap:1}
%if 0%{?fedora} >= 16
BuildRequires:	perl(Moo)
%endif
BuildRequires:	perl(Moose)
BuildRequires:	perl(MooseX::Role::Parameterized)
%if 0%{?fedora} >= 13 || 0%{?rhel} >= 7
BuildRequires:	perl(Mouse) >= 0.38
%endif
%endif
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Role::Tiny)

%description
This module lets you check your module's namespaces for imported functions you
might have forgotten to remove with namespace::autoclean or namespace::clean
and are therefore available to be called as methods, which usually isn't want
you want.

%prep
%setup -q -n Test-CleanNamespaces-%{version}

# We don't really need Module::Build::Tiny ≥ 0.035
%if %{old_mbt}
%patch0
%endif

# Patch out the requirement for Test::Requires if necessary
%if %(perl -e 'print $] >= 5.008008 ? 0 : 1;')
%patch1
%endif

# Test suite requires Test::More ≥ 0.94
%if %{test_more_lt094}
tar xfz %{SOURCE1}
find inc/Test -type f >> MANIFEST
%endif

%build
# Use our local Test::More if necessary
[ -d inc/Test/ ] && export PERL5LIB=$(pwd)/inc

perl Build.PL --installdirs=vendor
./Build

%install
rm -rf %{buildroot}
./Build install --destdir=%{buildroot} --create_packlist=0

%check
# Use our local Test::More if necessary
[ -d inc/Test/ ] && export PERL5LIB=$(pwd)/inc

./Build test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes CONTRIBUTING LICENSE README README.md
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::CleanNamespaces.3pm*

%changelog
* Sun Mar  9 2014 Paul Howarth <paul@city-fan.org> - 0.08-1
- Update to 0.08
  - Fixed method identification in Moose and Mouse roles
- Update patch for building without Test::Requires

* Mon Mar  3 2014 Paul Howarth <paul@city-fan.org> - 0.07-1
- Update to 0.07
  - Lots more tests
  - In failing tests, identify the source of the uncleaned sub(s)
  - Remove the dependency on Class::MOP by inspecting the package stash
    directly
- Switch to Module::Build::Tiny flow
- Package upstream's new CONTRIBUTING and README.md files
- Don't bother trying to run the extra tests
- Test suite actually requires Test::More ≥ 0.94, so bundle a suitable
  version to use if necessary
- Drop all existing patches
- Add a patch to support building with old Module::Build::Tiny versions
- Add a patch to support building without Test::Requires if necessary

* Wed Sep 25 2013 Paul Howarth <paul@city-fan.org> - 0.05-1
- Update to 0.05
  - Re-release with fixed compile test
- Update patches as needed

* Thu Sep 19 2013 Paul Howarth <paul@city-fan.org> - 0.04-2
- Don't run the extra tests when bootstrapping

* Sun Sep 15 2013 Paul Howarth <paul@city-fan.org> - 0.04-1
- Update to 0.04
  - Remove use of deprecated Class::MOP::load_class
- This release by ETHER -> update source URL
- Add patches to support building with old Test::More versions
- Add buildreqs for and explicitly run the extra tests

* Thu Jul 25 2013 Paul Howarth <paul@city-fan.org> - 0.03-2
- Perl 5.18 rebuild

* Sat Jun 29 2013 Paul Howarth <paul@city-fan.org> - 0.03-1
- Initial RPM version
